Bug 180345 - Review Request: ser - Sip Express Router
Review Request: ser - Sip Express Router
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jeffrey C. Ollie
Fedora Package Reviews List
:
: 173028 180344 (view as bug list)
Depends On:
Blocks: FE-ACCEPT
  Show dependency treegraph
 
Reported: 2006-02-07 09:21 EST by Andreas Thienemann
Modified: 2007-11-30 17:11 EST (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2006-04-12 22:53:11 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Andreas Thienemann 2006-02-07 09:21:23 EST
Spec Name or Url: http://helena.bawue.de/~ixs/ser/ser.spec
SRPM Name or Url: http://helena.bawue.de/~ixs/ser/ser-0.9.6-1.src.rpm
Everything else: http://helena.bawue.de/~ixs/ser/
Description:
A high-performance, configurable SIP server. It can act as registrar, proxy
or redirect server. It features an application-server interface, presence
support, SMS gateway, SIMPLE2Jabber gateway, RADIUS/syslog accounting and
authorization, server status monitoring, FCP security, etc.
Comment 1 Andreas Thienemann 2006-02-07 09:24:03 EST
*** Bug 180344 has been marked as a duplicate of this bug. ***
Comment 2 Jeffrey C. Ollie 2006-02-07 10:15:33 EST
First look... builds in mock on development, results of rpmlint:

[jcollie@lt16585 result]$ rpmlint ser-*0.9.6-1.i386.rpm
W: ser doc-file-dependency /usr/share/doc/ser-0.9.6/Jabber/regjab.pl
perl(DBD::mysql)
W: ser doc-file-dependency /usr/share/doc/ser-0.9.6/Jabber/regjab.pl /usr/bin/perl
W: ser doc-file-dependency /usr/share/doc/ser-0.9.6/Jabber/regjab.pl perl(Socket)

Perhaps renaming this to .txt will prevent rpm from picking up the dependencies?

W: ser service-default-enabled /etc/rc.d/init.d/ser

Please patch so that SER doesn't get enabled by default.

W: ser-mysql spelling-error-in-description persistant persistent
W: ser-postgresql spelling-error-in-description persistant persistent

Minor, but might as well fix since we're at it.

W: ser-postgresql doc-file-dependency
/usr/share/doc/ser-postgresql-0.9.6/copy_to_psql /usr/bin/perl

Perhaps renaming to .txt again will prevent RPM from picking up the dependency.

W: ser-serweb summary-ended-with-dot Web interface for ser user
self-provisioning and administration.

Please fix.

E: ser-serweb version-control-internal-file
/usr/share/serweb/templates/cache/.cvsignore
E: ser-serweb zero-length /usr/share/serweb/templates/cache/.cvsignore

Delete.

W: ser-serweb non-conffile-in-etc /etc/httpd/conf.d/serweb.conf

Mark as %config(noreplace)

E: ser-serweb version-control-internal-file
/usr/share/serweb/templates/configs/.cvsignore
E: ser-serweb zero-length /usr/share/serweb/templates/configs/.cvsignore

Delete.

E: ser-serweb version-control-internal-file
/usr/share/serweb/templates/templates_c/.cvsignore

Delete.

E: ser-serweb version-control-internal-file /usr/share/serweb/html/.cvsignore
E: ser-serweb zero-length /usr/share/serweb/html/.cvsignore

Delete.
Comment 3 Andreas Thienemann 2006-02-07 13:41:52 EST
.spec is updated.

I opted to remove the execute permissions on the perl scripts in the %docdir.
That is the preferred solution, even though rpmlint complains now with an Error
and not a Warning. *shrug*
Comment 4 Jeffrey C. Ollie 2006-02-07 14:04:50 EST
Please bump the revision number, even when the package is in the review process.
Comment 5 Peter Lemenkov 2006-02-07 15:04:54 EST
Look also at the 

https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=173028

Comment 6 Andreas Thienemann 2006-02-07 15:13:59 EST
(In reply to comment #5)

> https://bugzilla.redhat.com/bugzilla/show_bug.cgi?id=173028
I noticed that.
But as nothing happened there in the last 2 months, I thought that package was
probably dead.

Are you planning on maintaining the ser package in the future? Should we get
together and do it?
Comment 7 Jeffrey C. Ollie 2006-02-07 15:16:53 EST
I'm going to close this review request and mark it as a duplicate of #173028. 
Andreas, perhaps you and Peter can work together to get SER into FE.

*** This bug has been marked as a duplicate of 173028 ***
Comment 8 Andreas Thienemann 2006-02-07 15:20:04 EST
(In reply to comment #4)
> Please bump the revision number, even when the package is in the review process.
Uhm. As far as I know, this is not a requirement.

And personally, I do not believe in needlessly bumping a release number. When
the package is introduced into the repository, every change should be reflected
by the release number, but as long as it's in the review process, this is IMHO
unnecessary.
But if you insist, I can bump up the releasenumber. Everything to please the
reviewer. ;-D
Comment 9 Andreas Thienemann 2006-02-07 15:21:01 EST
(In reply to comment #7)
> I'm going to close this review request and mark it as a duplicate of #173028. 
> Andreas, perhaps you and Peter can work together to get SER into FE.
> 
> *** This bug has been marked as a duplicate of 173028 ***

The spec in 173028 is the template spec delivered with the ser-tarball.
Basically it's crap.
Comment 10 Jeffrey C. Ollie 2006-02-07 15:29:26 EST
(In reply to comment #9)
> (In reply to comment #7)
> > I'm going to close this review request and mark it as a duplicate of #173028. 
> > Andreas, perhaps you and Peter can work together to get SER into FE.
> > 
> > *** This bug has been marked as a duplicate of 173028 ***
> 
> The spec in 173028 is the template spec delivered with the ser-tarball.
> Basically it's crap.

The quality of the spec file that Peter submitted isn't the issue - Peter had
his review request first and should have been contacted first to see what the
status of his package was.  Since Peter still seems to be around let's let him
decide if he wants to defer packaging SER to Andreas.
Comment 11 Andreas Thienemann 2006-02-10 16:28:09 EST
According to Peter in #173028 it would be okay for me to introduce ser into
extras, given that some plugins are packaged as subpackages.

Jeff? That's okay with you?
Comment 12 Jeffrey C. Ollie 2006-02-10 16:41:43 EST
(In reply to comment #11)
> According to Peter in #173028 it would be okay for me to introduce ser into
> extras, given that some plugins are packaged as subpackages.
> 
> Jeff? That's okay with you?

Fine by me.
Comment 13 Jeffrey C. Ollie 2006-02-10 16:43:47 EST
*** Bug 173028 has been marked as a duplicate of this bug. ***
Comment 14 Andreas Thienemann 2006-02-10 18:14:46 EST
Great. In that case, I suggest we'll wait a few more days for peter to respond
to my request for clarification about packaging the pa, cpl-c and jabber plugins
as a seperate package, and then do a final review of the spec.

okay?
Comment 15 Andreas Thienemann 2006-02-16 02:06:41 EST
Jeff? I haven't heard back from Peter yet. Shall we go ahead and do a review of
the package as is?
Comment 16 Jeffrey C. Ollie 2006-02-16 09:00:29 EST
(In reply to comment #15)
> Jeff? I haven't heard back from Peter yet. Shall we go ahead and do a review of
> the package as is?

I'll try and do the full review sometime today, but it might be this evening
before I can get to it.
Comment 17 Peter Lemenkov 2006-02-16 16:23:57 EST
> About the different packages:
> But about the jabber, cpl-c and pa modules, I'm not so sure. All they depend 
> on are libxml2, expat and pthread.

I think that in any case it's a generally a good idea to split a package into a 
subpackages especialy if authors provide plugin-mechanism for their 
application. I personally prefer splitting to as many packages as could. Why 
break modularization and provide one big rpm?

Actually, I think that the question must be "why not to split SER into 
subackages" rather than "why split...?" :)


Comment 18 Jeffrey C. Ollie 2006-02-17 23:31:07 EST
Here's the full review:

- MUST: rpmlint must be run on every package. The output should
  be posted in the review.

Not OK:

[jcollie@lt16585 result]$ rpmlint ser-*.i386.rpm | grep -v debuginfo
W: ser-postgresql doc-file-dependency
/usr/share/doc/ser-postgresql-0.9.6/copy_to_psql /usr/bin/perl

Remove execute permission from this script and dependency shouldn't be picked up.

- MUST: The package must be named according to the Package
  Naming Guidelines.

OK

- MUST: The spec file name must match the base package %{name},
  in the format %{name}.spec

OK

- MUST: The package must meet the Packaging Guidelines.

OK, with the following notes:

Could the serweb html files be moved to /var/www/html/serweb?  This
could potentially be a problem with SELinux, as well as conforming
more to existing practice.

I see that serweb includes an (old) copy of the Smarty templating
system. Smarty is already in FE.  Is it possible to remove the copy
from serweb and use the newer version from FE?  It looks like you
could delete everything but smarty_serweb.php.  After patching up that
file (and manybe some others) you should be able to use the FE
version.

- MUST: The package must be licensed with an open-source
  compatible license and meet other legal requirements as
  defined in the legal section of Packaging Guidelines.

OK (GPL)

- MUST: The License field in the package spec file must match
  the actual license.

OK

- MUST: If (and only if) the source package includes the text of
  the license(s) in its own file, then that file, containing the
  text of the license(s) for the package must be included in
  %doc.

OK

- MUST: The spec file must be written in American English.

OK

- MUST: The spec file for the package MUST be legible. If the
  reviewer is unable to read the spec file, it will be
  impossible to perform a review. Fedora Extras is not the place
  for entries into the Obfuscated Code Contest ([WWW]
  http://www.ioccc.org/).

OK

- MUST: The sources used to build the package must match the
  upstream source, as provided in the spec URL. Reviewers should
  use md5sum for this task.

OK

31031225d483c0d5ac43e8eb5d0428e0  originals/ser-0.9.6_src.tar.gz
fa0647598c9370c91650386befd63fba  originals/serweb-0.9.4.tar.gz
31031225d483c0d5ac43e8eb5d0428e0  sources/ser-0.9.6_src.tar.gz
fa0647598c9370c91650386befd63fba  sources/serweb-0.9.4.tar.gz

- MUST: The package must successfully compile and build into
  binary rpms on at least one supported architecture.

OK (builds on i386/devel & i386/FC4)

- MUST: If the package does not successfully compile, build or
  work on an architecture, then those architectures should be
  listed in the spec in ExcludeArch. Each architecture listed in
  ExcludeArch needs to have a bug filed in bugzilla, describing
  the reason that the package does not compile/build/work on
  that architecture. The bug number should then be placed in a
  comment, next to the corresponding ExcludeArch line. New
  packages will not have bugzilla entries during the review
  process, so they should put this description in the comment
  until the package is approved, then file the bugzilla entry,
  and replace the long explanation with the bug number. The bug
  should be marked as blocking one (or more) of the following
  bugs to simplify tracking such issues: [WWW]
  FE-ExcludeArch-x86, [WWW] FE-ExcludeArch-x64, [WWW]
  FE-ExcludeArch-ppc

OK

- MUST: A package must not contain any BuildRequires that are
  listed in the exceptions section of Packaging Guidelines.

OK

- MUST: All other Build dependencies must be listed in
  BuildRequires.

OK

- MUST: The spec file MUST handle locales properly. This is done
  by using the %find_lang macro. Using %{_datadir}/locale/* is
  strictly forbidden.

OK (no localized files)

- MUST: If the package contains shared library files located in
  the dynamic linker's default paths, that package must call
  ldconfig in %post and %postun. If the package has multiple
  subpackages with libraries, each subpackage should also have a
  %post/%postun section that calls /sbin/ldconfig. An example of
  the correct syntax for this is:

  %post -p /sbin/ldconfig
  %postun -p /sbin/ldconfig

OK

- MUST: If the package is designed to be relocatable, the
  packager must state this fact in the request for review, along
  with the rationalization for relocation of that specific
  package. Without this, use of Prefix: /usr is considered a
  blocker.

OK (not relocatable)

- MUST: A package must own all directories that it creates. If
  it does not create a directory that it uses, then it should
  require a package which does create that directory. The
  exception to this are directories listed explicitly in the
  Filesystem Hierarchy Standard ([WWW]
  http://www.pathname.com/fhs/pub/fhs-2.3.html), as it is safe
  to assume that those directories exist.

Not OK (/etc/ser not owned by main package.)

- MUST: A package must not contain any duplicate files in the
  %files listing.

Not OK (/etc/ser/serweb is duplicated between main package and serweb
subpackage.)

- MUST: Permissions on files must be set properly. Executables
  should be set with executable permissions, for example. Every
  %files section must include a %defattr(...) line.

OK

- MUST: Each package must have a %clean section, which contains
  rm -rf %{buildroot} (or $RPM_BUILD_ROOT).

OK

- MUST: Each package must consistently use macros, as described
  in the macros section of Packaging Guidelines.

Not OK (%clean section uses $RPM_BUILD_ROOT while %{buildroot} is used elsewhere.)

- MUST: The package must contain code, or permissable
  content. This is described in detail in the code vs. content
  section of Packaging Guidelines.

OK

- MUST: Large documentation files should go in a -docs
  subpackage. (The definition of large is left up to the
  packager's best judgement, but is not restricted to
  size. Large can refer to either size or quantity)

OK

- MUST: If a package includes something as %doc, it must not
  affect the runtime of the application. To summarize: If it is
  in %doc, the program must run properly if it is not present.

OK

- MUST: Header files or static libraries must be in a -devel
  package.

OK

- MUST: Files used by pkgconfig (.pc files) must be in a -devel
  package.

OK

- MUST: If a package contains library files with a suffix
  (e.g. libfoo.so.1.1), then library files that end in .so
  (without suffix) must go in a -devel package.

OK

- MUST: In the vast majority of cases, devel packages must
  require the base package using a fully versioned dependency.

OK

- MUST: Packages must NOT contain any .la libtool archives,
  these should be removed in the spec.

OK

- MUST: Packages containing GUI applications must include a
  %{name}.desktop file, and that file must be properly installed
  with desktop-file-install in the %install section. This is
  described in detail in the desktop files section of Packaging
  Guidelines. If you feel that your packaged GUI application
  does not need a .desktop file, you must put a comment in the
  spec file with your explanation.

OK

- MUST: Packages must not own files or directories already owned
  by other packages. The rule of thumb here is that the first
  package to be installed should own the files or directories
  that other packages may rely upon. This means, for example,
  that no package in Fedora Extras should ever share ownership
  with any of the files or directories owned by the filesystem
  or man package. If you feel that you have a good reason to own
  a file or directory that another package owns, then please
  present that at package review time.

OK

- SHOULD: If the source package does not include license text(s) as a
  separate file from upstream, the packager SHOULD query upstream to
  include it.

OK

- SHOULD: The description and summary sections in the package spec
  file should contain translations for supported Non-English
  languages, if available.

OK

- SHOULD: The reviewer should test that the package builds in mock.

OK (build in mock devel/i386)

- SHOULD: The package should compile and build into binary rpms on all
  supported architectures.

Tested i386/devel and i386/FC4.

- SHOULD: The reviewer should test that the package functions as
  described. A package should not segfault instead of running, for
  example.

OK (only main package tested)

- SHOULD: If scriptlets are used, those scriptlets must be sane. This
  is vague, and left up to the reviewers judgement to determine
  sanity.

OK

- SHOULD: Usually, subpackages other than devel should require the
  base package using a fully versioned dependency.

OK

Needs a bit more work, and then I'll approve it...

Comment 19 Jeffrey C. Ollie 2006-02-17 23:32:43 EST
Also, it would be nice to have the radius modules, but since that appears to
need the radiusclient-ng package that can wait until radiusclient-ng is included
in FE.
Comment 20 Andreas Thienemann 2006-02-18 09:42:05 EST
> W: ser-postgresql doc-file-dependency
/usr/share/doc/ser-postgresql-0.9.6/copy_to_psql /usr/bin/perl

Thanks. That's fixed now.


> Not OK (/etc/ser not owned by main package.)

Fixed.

> Could the serweb html files be moved to /var/www/html/serweb?  This
> could potentially be a problem with SELinux, as well as conforming
> more to existing practice.

Let me look into this. I oriented myself at the squirrelmail package, which is
one of the few webapps included in RHEL and Fedora. This package has its
datafiles in /usr/share/%{name}.

But the part about depending on smarty and removing the internal smarty_template
system is a good idea. I'll see to it, that this part is changed.
Good idea security-wise.
Comment 21 Andreas Thienemann 2006-02-18 12:42:10 EST
Uhm. I just tried removing smarty from serweb in favour of using the
system-installed one.
Unfortunately, I failed horribly. ;)

The default smarty code is extended quite a bit by different plugins included by
serweb.
This might pose a problem.

Thus I'd suggest, we postpone the smarty work a bit and include the ser package
as is for now.

I just updated the spec, to fix the remaining problems but left the smarty work
for later.
Comment 22 Jeffrey C. Ollie 2006-02-22 23:33:51 EST
I'm still getting some files listed twice:

warning: File listed twice: /etc/ser/dictionary.ser
warning: File listed twice: /etc/ser/ser.cfg
warning: File listed twice: /etc/ser/serweb
warning: File listed twice: /etc/ser/serweb/config.php
warning: File listed twice: /etc/ser/serweb/config_data_layer.php
warning: File listed twice: /etc/ser/serweb/config_domain_defaults.php
warning: File listed twice: /etc/ser/serweb/config_lang.php
warning: File listed twice: /etc/ser/serweb/config_paths.php
warning: File listed twice: /etc/ser/serweb/set_domain.php
Comment 23 Paul Howarth 2006-02-23 02:51:02 EST
(In reply to comment #22)
> I'm still getting some files listed twice:
> 
> warning: File listed twice: /etc/ser/dictionary.ser
> warning: File listed twice: /etc/ser/ser.cfg
> warning: File listed twice: /etc/ser/serweb
> warning: File listed twice: /etc/ser/serweb/config.php
> warning: File listed twice: /etc/ser/serweb/config_data_layer.php
> warning: File listed twice: /etc/ser/serweb/config_domain_defaults.php
> warning: File listed twice: /etc/ser/serweb/config_lang.php
> warning: File listed twice: /etc/ser/serweb/config_paths.php
> warning: File listed twice: /etc/ser/serweb/set_domain.php

I was going to take a look at this but the only spec URL I can see in this
ticket seems to be for the initial submission. Where's the latest one?


Comment 24 Jeffrey C. Ollie 2006-02-23 09:08:14 EST
(In reply to comment #23)
> (In reply to comment #22)
> > I'm still getting some files listed twice:
> > 
> > warning: File listed twice: /etc/ser/dictionary.ser
> > warning: File listed twice: /etc/ser/ser.cfg
> > warning: File listed twice: /etc/ser/serweb
> > warning: File listed twice: /etc/ser/serweb/config.php
> > warning: File listed twice: /etc/ser/serweb/config_data_layer.php
> > warning: File listed twice: /etc/ser/serweb/config_domain_defaults.php
> > warning: File listed twice: /etc/ser/serweb/config_lang.php
> > warning: File listed twice: /etc/ser/serweb/config_paths.php
> > warning: File listed twice: /etc/ser/serweb/set_domain.php
> 
> I was going to take a look at this but the only spec URL I can see in this
> ticket seems to be for the initial submission. Where's the latest one?

Andreas has been updating the SPEC/SRPM without bumping the release number.  The
new package process guideline should be revised to discourage this.
Comment 25 Paul Howarth 2006-02-23 09:17:30 EST
(In reply to comment #24)
> (In reply to comment #23)
> > (In reply to comment #22)
> > > I'm still getting some files listed twice:
> > > 
> > > warning: File listed twice: /etc/ser/dictionary.ser
> > > warning: File listed twice: /etc/ser/ser.cfg
> > > warning: File listed twice: /etc/ser/serweb
> > > warning: File listed twice: /etc/ser/serweb/config.php
> > > warning: File listed twice: /etc/ser/serweb/config_data_layer.php
> > > warning: File listed twice: /etc/ser/serweb/config_domain_defaults.php
> > > warning: File listed twice: /etc/ser/serweb/config_lang.php
> > > warning: File listed twice: /etc/ser/serweb/config_paths.php
> > > warning: File listed twice: /etc/ser/serweb/set_domain.php
> > 
> > I was going to take a look at this but the only spec URL I can see in this
> > ticket seems to be for the initial submission. Where's the latest one?
> 
> Andreas has been updating the SPEC/SRPM without bumping the release number.  The
> new package process guideline should be revised to discourage this.

Agreed. The guidelines should also encourage the addition of changelog
information in the spec during the review process.
Comment 26 Jeffrey C. Ollie 2006-03-08 22:02:46 EST
(In reply to comment #22)
> I'm still getting some files listed twice:
> 
> warning: File listed twice: /etc/ser/dictionary.ser
> warning: File listed twice: /etc/ser/ser.cfg
> warning: File listed twice: /etc/ser/serweb
> warning: File listed twice: /etc/ser/serweb/config.php
> warning: File listed twice: /etc/ser/serweb/config_data_layer.php
> warning: File listed twice: /etc/ser/serweb/config_domain_defaults.php
> warning: File listed twice: /etc/ser/serweb/config_lang.php
> warning: File listed twice: /etc/ser/serweb/config_paths.php
> warning: File listed twice: /etc/ser/serweb/set_domain.php

Andreas, any updates on this?  If you can get the duplicate files problem taken
care of I think that I can approve this package.
Comment 27 Andreas Thienemann 2006-03-20 09:51:04 EST
Okay. Sorry for the delay, I was on vacation.
The spec and srpms are updated. And for the next release, I'm even gonna bump
the release number. ;)
I hope I fixed the "file listed twice" part.
Where did you see that warning in the past? During the rpmbuild?
Comment 28 Jeffrey C. Ollie 2006-03-20 10:10:46 EST
(In reply to comment #27)
> Okay. Sorry for the delay, I was on vacation.
> The spec and srpms are updated. And for the next release, I'm even gonna bump
> the release number. ;)
> I hope I fixed the "file listed twice" part.
> Where did you see that warning in the past? During the rpmbuild?

Still getting some duplicate file warnings, although fewer than before. Yes, the
error shows up during rpmbuild.

> warning: File listed twice: /etc/ser/dictionary.ser
> warning: File listed twice: /etc/ser/ser.cfg
> warning: File listed twice: /etc/ser/serweb

Also, these lines in the latest spec file are incorrect:

> %dir %{_sysconfdir}/ser/*
> %config(noreplace) %{_sysconfdir}/ser

I think that what you really probably want is:

%dir %{_sysconfdir}/ser
%config(noreplace) %{_sysconfdir}/dictionary.ser
%config(noreplace) %{_sysconfdir}/ser.cfg

%dir %{_sysconfdir}/ser/serweb
%config(noreplace) %{_sysconfdir}/ser/serweb/*.php
Comment 29 Andreas Thienemann 2006-03-28 07:21:31 EST
Okay, I think I fixed the duplicate file issue.

New SRPM: http://home.bawue.de/~ixs/ser-0.9.6-2.src.rpm
New SPEC: http://home.bawue.de/~ixs/ser.spec
Comment 30 Jeffrey C. Ollie 2006-03-28 09:17:09 EST
Shouldn't those URLs should be:

New SRPM: http://home.bawue.de/~ixs/ser/ser-0.9.6-2.src.rpm
New SPEC: http://home.bawue.de/~ixs/ser/ser.spec

Anyway, I found them, and it looks good.

APPROVED

Note You need to log in before you can comment on or make changes to this bug.